# MatSeqBAIJSetPreallocation

Sets the block size and expected nonzeros per row in the matrix. For good matrix assembly performance the user should preallocate the matrix storage by setting the parameter nz (or the array nnz). By setting these parameters accurately, performance during matrix assembly can be increased by more than a factor of 50.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode PETSCMAT_DLLEXPORT MatSeqBAIJSetPreallocation(Mat B,PetscInt bs,PetscInt nz,const PetscInt nnz[])

Collective on MPI_Comm

### Input Parameters

| A | - the matrix
| bs | - size of block
| nz | - number of block nonzeros per block row (same for all rows)
| nnz | - array containing the number of block nonzeros in the various block rows (possibly different for each block row) or PETSC_NULL

### Options Database Keys

-mat_no_unroll -uses code that does not unroll the loops in the block calculations (much slower)
-mat_block_size -size of the blocks to use

### C++ variants

| MatSeqBAIJSetPreallocation(Mat A,PetscInt bs,const PetscInt nnz[]) |  | -> |  | MatSeqBAIJSetPreallocation(A,bs,0,nnz)

### Notes

If the nnz parameter is given then the nz parameter is ignored

The block AIJ format is fully compatible with standard Fortran 77 storage. That is, the stored row and column indices can begin at either one (as in Fortran) or zero. See the users' manual for details.

Specify the preallocated storage with either nz or nnz (not both). Set nz=PETSC_DEFAULT and nnz=PETSC_NULL for PETSc to control dynamic memory allocation. For additional details, see the users manual chapter on matrices.

### See Also

MatCreate(), MatCreateSeqAIJ(), MatSetValues(), MatCreateMPIBAIJ()

Level:intermediate
Location: src/mat/impls/baij/seq/baij.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages